
function [SUMMARY, DESIGNS] = compare

%% Inputs:
%% genetic(n, N0, N, eps, model, params, nx, unchangedLimit, popSize, crossoverProb, initMutationProb, finalMutationProb, eliteProp, indesign)

n = 10;
N0 = 75;
N = 100;

eps0 = 0;
eps = .25;
phi = .5; % ar parameter
theta = .9; % ma parameter
params = [phi 1 -.5 theta  -1 .6];
params0 = [0 1 -.5  0  -1 .6];
nx = 1001;
unchangedLimit = 1000;
popSize = 40;
crossoverProb = .95;
initMutationProb = .2;
finalMutationProb = 0;
eliteProp = .2;

SUMMARY = zeros(4,6);


%% AR(1):
% First compute 'optimal' (eps = 0) design:
[bestdesign, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~] = ...
	genetic(n, N0, N, eps0, 'AR1', params, nx, unchangedLimit, popSize, crossoverProb, initMutationProb, finalMutationProb, eliteProp, []);
% Use this as input:
optimaldesign = bestdesign;
[bestdesign, f0, fstar, R0, Rstar, fnKn, normKn, amspe, amspe0, amspeU, amspeU0, amspein, amspein0, omega, lossingenerations, n, N0, N, eps, model, ~] = ...
	genetic(n, N0, N, eps, 'AR1', params, nx, unchangedLimit, popSize, crossoverProb, initMutationProb, finalMutationProb, eliteProp, optimaldesign);
SUMMARY(1,:) = [amspe0, amspe, amspein0, amspein, amspeU0, amspeU];
DESIGNS1 = [bestdesign; optimaldesign; round(N0*((1:n)-.5*ones(1,n))/n); zeros(1,n)];
save ar1compare.mat
%pause

%%MA(1):
% First compute 'optimal' (eps = 0) design:
[bestdesign, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~] = ...
	genetic(n, N0, N, eps0, 'MA1', params, nx, unchangedLimit, popSize, crossoverProb, initMutationProb, finalMutationProb, eliteProp, []);
% Use this as input:
optimaldesign = bestdesign;
[bestdesign, f0, fstar, R0, Rstar, ~, ~, amspe, amspe0, amspeU, amspeU0, amspein, amspein0, omega, lossingenerations, n, N0, N, eps, model, ~] = ...
	genetic(n, N0, N, eps, 'MA1', params, nx, unchangedLimit, popSize, crossoverProb, initMutationProb, finalMutationProb, eliteProp, optimaldesign);
SUMMARY(2,:) = [amspe0, amspe, amspein0, amspein, amspeU0, amspeU];
DESIGNS2 = [bestdesign; optimaldesign; round(N0*((1:n)-.5*ones(1,n))/n); zeros(1,n)];
save ma1compare.mat
%pause

%%ARMA(1,1):
% First compute 'optimal' (eps = 0) design:
[bestdesign, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~] = ...
	genetic(n, N0, N, eps0, 'ARMA11', params, nx, unchangedLimit, popSize, crossoverProb, initMutationProb, finalMutationProb, eliteProp, []);
% Use this as input:
optimaldesign = bestdesign;
[bestdesign, f0, fstar, R0, Rstar, ~, ~, amspe, amspe0, amspeU, amspeU0, amspein, amspein0, omega, lossingenerations, n, N0, N, eps, model, ~] = ...
	genetic(n, N0, N, eps, 'ARMA11', params, nx, unchangedLimit, popSize, crossoverProb, initMutationProb, finalMutationProb, eliteProp, optimaldesign);
SUMMARY(3,:) = [amspe0, amspe, amspein0, amspein, amspeU0, amspeU];
DESIGNS3 = [bestdesign; optimaldesign; round(N0*((1:n)-.5*ones(1,n))/n); zeros(1,n)];
save arma11compare.mat
%pause

%%white noise (= AR(1) with rho = 0):
% First compute 'optimal' (eps = 0) design:
[bestdesign, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~, ~] = ...
	genetic(n, N0, N, eps0, 'AR1', params0, nx, unchangedLimit, popSize, crossoverProb, initMutationProb, finalMutationProb, eliteProp, []);
% Use this as input:
optimaldesign = bestdesign;
[bestdesign, f0, fstar, R0, Rstar, ~, ~, amspe, amspe0, amspeU, amspeU0, amspein, amspein0, omega, lossingenerations, n, N0, N, eps, model, ~] = ...
	genetic(n, N0, N, eps, 'AR1', params0, nx, unchangedLimit, popSize, crossoverProb, initMutationProb, finalMutationProb, eliteProp, optimaldesign);
SUMMARY(4,:) = [amspe0, amspe, amspein0, amspein, amspeU0, amspeU];
DESIGNS4 = [bestdesign; optimaldesign; round(N0*((1:n)-.5*ones(1,n))/n); zeros(1,n)];
save whitecompare.mat

DESIGNS = [DESIGNS1; DESIGNS2; DESIGNS3; DESIGNS4];
SUMMARY = myround(SUMMARY, 3);


%% ============================= subfunction "myround" =============================
function y = myround(x, d)
y = round(x*10^d)/10^d;

