
%% Run genetic.m, which saves its output to 'thisoutput.mat'.
%% This function prepares plots as in Figures 1 and 2 (again).

function figx


%initialize eps so that 'machine eps' isn't used:
eps = 19;

%load a file:
load thisoutput.mat %% as an example

desIndices = zeros(1,N0);
desIndices(bestdesign) = 1;
figure(1);

subplot(2,2,1);
plot(lossingenerations);
string0 = ['AMSPE = ', num2str(myround(amspe, 3))]; 
legend(string0);
xlabel('(a) Minloss vs. generation');

subplot(2,2,2);
bar(desIndices, .01);
xlim([0 N0+1]);
xlabel('(b) Best design')

subplot(2,2,3);
plot(omega, fstar, '-r', omega, f0, '-.b');
xlim([-pi pi]);
legend('f_{**}','f_{0}');
xlabel('(c) spectral densities');

subplot(2,2,4);
last = 7;
plot(0:(last-1), Rstar(1:last)', '-r', 0:(last-1), R0(1:last), '-.b');
xlim([0 last - .5]);
ylim([-1 1]);
xlabel('(d) autocorrelation functions')

display(['Model ', model, '  eps = ', num2str(eps), '  amspe = ', ...
    num2str(myround(amspe,3)), '  best design is ', num2str(bestdesign)]);



%% ============================= subfunction "myround" =============================
function y = myround(x, d)
y = round(x*10^d)/10^d;

